//+------------------------------------------------------------------+
//|                                            Kijun-sen-smothed.mq4 |
//|                                        Copyright  2007, Kalenzo |
//|                                             http://fxservice.eu/ |
//|                     Orginal Kijun-sen code was made by AlexSilver|                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Kalenzo, bartlomiej.gorski@gmail.com"
#property link      "http://fxservice.eu/"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 DeepSkyBlue
//---- input parameters
extern int Kijun=26;
extern int ShiftKijun=3;
//---- buffers
double Kijun_Buffer[];
extern int  ma_period = 5,
            ma_method = MODE_SMA;

//----
int a_begin;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Kijun_Buffer);
   SetIndexDrawBegin(0,Kijun+ShiftKijun-1);
   SetIndexShift(0,ShiftKijun);
   SetIndexLabel(0,"Kijun Sen+");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Ichimoku Kinko Hyo Kijun-sen Only                                |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k;
   int    counted_bars=IndicatorCounted();
   double high,low,price;
//----
   if(Bars<=Kijun) return(0);
//---- initial zero
   if(counted_bars<1)
     {
      for(i=1;i<=Kijun;i++)     Kijun_Buffer[Bars-i]=0;
     }
//---- Kijun Sen
   i=Bars-Kijun;
   if(counted_bars>Kijun) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=iMA(Symbol(),0,ma_period,0,ma_method,PRICE_HIGH,i); 
      low=iMA(Symbol(),0,ma_period,0,ma_method,PRICE_LOW,i); 
      k=i-1+Kijun;
      
      while(k>=i)
        {
         price=iMA(Symbol(),0,ma_period,0,ma_method,PRICE_HIGH,k);
         if(high<price) high=price;
         price=iMA(Symbol(),0,ma_period,0,ma_method,PRICE_LOW,k);
         if(low>price) low=price;
         k--;
        }
      Kijun_Buffer[i+ShiftKijun]=(high+low)/2;
      i--;
     } i=ShiftKijun-1;
   while(i>=0)
     {
      high=iMA(Symbol(),0,ma_period,0,ma_method,PRICE_HIGH,0); 
      low=iMA(Symbol(),0,ma_period,0,ma_method,PRICE_LOW,0); 
      k=Kijun-ShiftKijun+i;
      
      while(k>=0)
        {
         price=iMA(Symbol(),0,ma_period,0,ma_method,PRICE_HIGH,k);
         if(high<price) high=price;
         price=iMA(Symbol(),0,ma_period,0,ma_method,PRICE_LOW,k);
         if(low>price) low=price;
         k--;
        }
      Kijun_Buffer[i]=(high+low)/2;
      i--;
     }
   }
//+------------------------------------------------------------------+